/*

*/

import renderer.scene.Scene;
import renderer.scene.Model;
import renderer.framebuffer.FrameBufferPanel;

import javax.swing.JFrame;
import java.util.List;
import java.util.ArrayList;

/**
   This class holds all the client state information
   needed by the client's event handlers.
*/
public class ClientState
{
   protected FrameBufferPanel fbp = null;
   protected Scene scene = null;
   protected final List<Model> modelArray = new ArrayList<>();
   protected int currentModel = 0;
   protected double[] deltaX = {0.0};
   protected double[] deltaY = {0.0};
   protected double[] deltaZ = {0.0};
   protected double[] deltaS = {1.0};
   protected boolean displayTransformations = false;


   public static void print_help_message()
   {
      System.out.println("Use the 'd' key to toggle debugging information on and off for the current model.");
      System.out.println("Use the '/' key to cycle through the models.");
      System.out.println("Use the 'p' key to toggle between parallel and orthographic projection.");
      System.out.println("Use the x/X, y/Y, z/Z, keys to translate the model along the x, y, z axes.");
      System.out.println("Use the s/S keys to scale the size of the model.");
      System.out.println("Use the 'm' key to toggle the display of transformation information.");
      System.out.println("Use the 'c' key to toggle line clipping on and off.");
      System.out.println("Use the 'h' key to redisplay this help message.");
   }
}
