/*

*/

import renderer.pipeline.*;
import renderer.framebuffer.*;

import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;

/**

*/
class ComponentHandler extends ComponentAdapter
{
   private final ClientState client;

   public ComponentHandler(ClientState client)
   {
      this.client = client;
   }


   @Override public void componentResized(ComponentEvent e)
   {
      //System.out.println( e );

      System.out.printf("JFrame [w = %d, h = %d]: " +
                        "FrameBufferPanel [w = %d, h = %d].\n",
                        client.fbp.getTopLevelAncestor().getWidth(),
                        client.fbp.getTopLevelAncestor().getHeight(),
                        client.fbp.getWidth(), client.fbp.getHeight());

      // Get the new size of the FrameBufferPanel.
      final int w = client.fbp.getWidth();
      final int h = client.fbp.getHeight();

      // Create a new FrameBuffer that fits the FrameBufferPanel.
      final FrameBuffer fb = new FrameBuffer(w, h);
      client.fbp.setFrameBuffer(fb);
      Pipeline.render(client.scene, fb);
      client.fbp.update();
   }
}
