/*

*/

import renderer.scene.*;
import renderer.models.*;
import renderer.framebuffer.FrameBufferPanel;

import javax.swing.JFrame;
import java.awt.BorderLayout;
import java.io.File;

/**

*/
public class InteractiveModelsAll_R2
{
   /**
      This constructor instantiates the Scene object
      and initializes it with appropriate geometry.
      Then this constructor instantiates the GUI.
   */
   public InteractiveModelsAll_R2()
   {
      // Create an object that can hold all the client state information.
      final ClientState state = new ClientState();

      // Create the Scene object that we shall render
      state.scene = new Scene();
/*
      // Create several Model objects, using default constructors.
      state.modelArray.add(new Square());
      state.modelArray.add(new SquareGrid());
      state.modelArray.add(new Circle());
      state.modelArray.add(new Disk());
      state.modelArray.add(new DiskSector());
      state.modelArray.add(new Ring());
      state.modelArray.add(new RingSector());
      state.modelArray.add(new Box());
      state.modelArray.add(new Cube());
      state.modelArray.add(new Cube2());
      state.modelArray.add(new Cube3());
      state.modelArray.add(new Cube4());
      state.modelArray.add(new Tetrahedron());
      state.modelArray.add(new Octahedron());
      state.modelArray.add(new Icosahedron());
      state.modelArray.add(new Dodecahedron());
      state.modelArray.add(new Pyramid());
      state.modelArray.add(new PyramidFrustum());
      state.modelArray.add(new TriangularPyramid());
      state.modelArray.add(new TriangularPrism());
      state.modelArray.add(new ViewFrustum());
      state.modelArray.add(new Cone());
      state.modelArray.add(new ConeSector());
      state.modelArray.add(new ConeFrustum());
      state.modelArray.add(new Cylinder());
      state.modelArray.add(new CylinderSector());
      state.modelArray.add(new Sphere());
      state.modelArray.add(new SphereSector());
      state.modelArray.add(new SphereSubdivided());
      state.modelArray.add(new Torus());
      state.modelArray.add(new TorusSector());
      state.modelArray.add(new ParametricCurve());
      state.modelArray.add(new ParametricSurface());
      state.modelArray.add(new SurfaceOfRevolution());
      state.modelArray.add(new Axes3D());
      state.modelArray.add(new Axes2D());
      state.modelArray.add(new PanelXY());
*/
      // Instantiate at least one of every Model class.
      // 2D models
      state.modelArray.add(new Square(1.0));
      state.modelArray.add(new SquareGrid(1.0, 11, 15));
      state.modelArray.add(new Circle(1.0, 16));
      state.modelArray.add(new Disk(1.0, 4, 16));
      state.modelArray.add(new DiskSector(1.0, Math.PI/2, 3*Math.PI/2, 4, 8));
      state.modelArray.add(new Ring(1.0, 0.25, 3, 16));
      state.modelArray.add(new RingSector(1.0, 0.25, Math.PI/2, 3*Math.PI/2, 3, 8));
      state.modelArray.add(new Triangle(45, 4)); // try 5 or 6
      // cubes
      state.modelArray.add(new Box(1.0, 1.0, 1.0));
      state.modelArray.add(new Cube( ));
      state.modelArray.add(new Cube2(4, 5, 6));
      state.modelArray.add(new Cube3(12, 14, 15));
      state.modelArray.add(new Cube4(12, 14, 15));
      // polyhedra
      state.modelArray.add(new Tetrahedron());
      state.modelArray.add(new Tetrahedron(true));
      state.modelArray.add(new Octahedron());
      state.modelArray.add(new Icosahedron());
      state.modelArray.add(new Dodecahedron());
      // pyramids
      state.modelArray.add(new Pyramid(2.0, 1.0, 5, 6));
      state.modelArray.add(new Pyramid(2.0, 1.0, 5, 6, true));
      state.modelArray.add(new PyramidFrustum(2.0, 1.0, 0.5, 2, 5));
      state.modelArray.add(new PyramidFrustum(1.0, 2.0, 0.5, 2, 5));
      state.modelArray.add(new TriangularPyramid(Math.sqrt(3)/Math.sqrt(2)));
      state.modelArray.add(new TriangularPyramid(1.0, 1.0, 7, 7));
      state.modelArray.add(new TriangularPrism(0.6, 0.5, 0.5, 3, true));
      state.modelArray.add(new ViewFrustumModel());
      // cones
      state.modelArray.add(new Cone(1.0, 1.0, 10, 16));
      state.modelArray.add(new ConeSector(1.0, 1.0, 0.5, 0, 2*Math.PI, 5, 16));
      state.modelArray.add(new ConeSector(1.0, 1.0, 0.5, Math.PI/2, 3*Math.PI/2, 5, 8));
      state.modelArray.add(new ConeFrustum(1.0, 0.5, 0.5, 6, 16));
      state.modelArray.add(new ConeFrustum(0.5, 1.0, 0.5, 6, 16));
      // cylinders
      state.modelArray.add(new Cylinder(0.5, 1.0, 11, 12));
      state.modelArray.add(new CylinderSector(0.5, 1.0, Math.PI/2, 3*Math.PI/2, 11, 6));
      // spheres
      state.modelArray.add(new Sphere(1.0, 15, 12));
      state.modelArray.add(new SphereSector(1.0, Math.PI/2, 3*Math.PI/2,
                                           Math.PI/4, 3*Math.PI/4, 7, 6));
      state.modelArray.add(new SphereSubdivided(5));
      state.modelArray.add(new SphereSubdivided(6, true, false));
      state.modelArray.add(new SphereSubdivided(7, false, true));
      // torus
      state.modelArray.add(new Torus(0.75, 0.25, 12, 16));
      state.modelArray.add(new TorusSector(0.75, 0.25, Math.PI/2, 3*Math.PI/2, 12, 8));
      state.modelArray.add(new TorusSector(0.75, 0.25, 0, 2*Math.PI,
                                                 Math.PI, 2*Math.PI, 6, 16));
      state.modelArray.add(new TorusSector(0.75, 0.25, 0, 2*Math.PI,
                                                -Math.PI/2, Math.PI/2, 6, 16));
      state.modelArray.add(new TorusSector(0.75, 0.25, Math.PI/2, 3*Math.PI/2,
                                                -Math.PI/2, Math.PI/2, 6, 8));
      // model files
      state.modelArray.add(new GRSModel(new File("../assets/grs/bronto.grs")));
      state.modelArray.add(new ObjSimpleModel(new File("../assets/cow.obj")));
      // parametric curves and surfaces
      state.modelArray.add(new ParametricCurve());
      state.modelArray.add(new ParametricSurface());
      state.modelArray.add(new ParametricSurface(
                (s,t)->s*Math.cos(t*Math.PI),
                (s,t)->t,
                (s,t)->s*Math.sin(t*Math.PI),
                -1, 1, -1, 1, 49, 49));
      state.modelArray.add(new ParametricSurface(
                (u,v)->0.3*(1-u)*(3+Math.cos(v))*Math.sin(4*Math.PI*u),
                (u,v)->0.3*(3*u+(1-u)*Math.sin(v)),
                (u,v)->0.3*(1-u)*(3+Math.cos(v))*Math.cos(4*Math.PI*u),
                0, 1, 0, 2*Math.PI, 49, 49));
      state.modelArray.add(new SurfaceOfRevolution());
      state.modelArray.add(new SurfaceOfRevolution(t->0.5*(1+t*t), -1, 1, 30, 30));
      state.modelArray.add(new SurfaceOfRevolution(t->t, t->4*t*(1-t), 0, 1, 30, 30));
      // coordinate axes
      state.modelArray.add(new Axes3D(1, 1, 1));
      state.modelArray.add(new Axes2D(-1, 1, -1, 1, 8, 8));
      state.modelArray.add(new PanelXY(-4, 4, -5, 5, -5));
      state.modelArray.add(new PanelXZ(-1, 1, -6, 1, -0.5));
      state.modelArray.add(new PanelYZ(-1, 1, -6, 1, -0.5));

      // Add a model to the Scene.
      state.scene.addModel(state.modelArray.get(state.currentModel));

      // Push the models away from where the camera is.
      for (final Model m : state.modelArray)
      {
         for (int i = 0; i < m.vertexList.size(); ++i)
         {
            final Vertex v = m.vertexList.get(i);
            m.vertexList.set(i, new Vertex(v.x,
                                           v.y,
                                           v.z - 2));
         }
      }


      // Define initial dimensions for a FrameBuffer.
      final int width  = 1024;
      final int height = 1024;

      // Create a FrameBufferPanel that holds a FrameBuffer.
      state.fbp = new FrameBufferPanel(width, height);

      // Create a JFrame that will hold the FrameBufferPanel.
      final JFrame jf = new JFrame("Renderer 2");
      jf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    //jf.setLocationByPlatform(true);
      // Place the FrameBufferPanel in the JFrame.
      jf.getContentPane().add(state.fbp, BorderLayout.CENTER);
      jf.pack();
      jf.setVisible(true);

      // Create event handler objects for events from the JFrame.
      jf.addKeyListener(new KeyHandler_v2(state));
      jf.addComponentListener(new ComponentHandler(state));
   }


   /**
      Create an instance of this class which has
      the affect of creating the GUI application.
   */
   public static void main(String[] args)
   {
      ClientState.print_help_message();

      // We need to call the program's constructor in the
      // Java GUI Event Dispatch Thread, otherwise we get a
      // race condition between the constructor (running in
      // the main() thread) and the very first ComponentEvent
      // (running in the EDT).
      javax.swing.SwingUtilities.invokeLater(
         () -> new InteractiveModelsAll_R2()
      );
   }
}
